package com.corejdo.casestudy.usecase;
import com.corejdo.casestudy.tools.*;
import com.corejdo.casestudy.model.*;
import javax.jdo.*;
import java.util.*;

public class DeleteBook extends BookOperation
{
    public static void main(String[] args)
    {
        new DeleteBook().runCmdLine(args);
    }

    /**
     * Command line version.
     */
    protected void run(String[] args)
    {
        setFindISBN(CmdLine.getStringVar("Find ISBN","928394-234-23444"));
        setFindTitle(CmdLine.getStringVar("Find Title",""));
        execute();
    }

    public boolean isAllowed()
    {
        return getContext().userRights.canManage();
    }

    /**
     * First, looks up a book, then delete it.
     */
    protected void _execute()
    {
        Book book = findBook();
        PersistenceManager pm = getPM();
        pm.deletePersistent(book);
    }
}