package com.corejdo.casestudy.usecase;


import com.corejdo.casestudy.model.Book;
import com.corejdo.casestudy.tools.CmdLine;

import javax.jdo.*;

import java.util.*;
import java.text.DateFormat;
import java.text.ParseException;

/**
 * This class is used to change properties of books.
 *
 * @author Heiko Bobzin, Keiron McCammon, Sameer Tyagi, Michael Vorburger
 * @version 1.0
 */

public class EditBook extends BookOperation
{
    public static void main(String[] args)
    {
        new EditBook().runCmdLine(args);
    }

    /**
     * Command line version of the book editor.
     *
     */
    protected void run(String[] args)
    {
        setFindISBN(CmdLine.getStringVar("Find ISBN","928394-234-23444"));
        setFindTitle(CmdLine.getStringVar("Find Title",""));
        setISBN(CmdLine.getStringVar("ISBN","928394-234-23444"));
        setTitle(CmdLine.getStringVar("Title","new Title"));
        setAuthor(CmdLine.getStringVar("Author","H. Bobzin"));
        setCopyright(CmdLine.getStringVar("Copyright","(C) 2003 Prentice Hall"));
        execute();
    }


    /**
     * First, looks up a book, then updates the fields with
     * the values of this bean.
     */
    protected void _execute()
    {
        Book book = findBook();
        book.title = this.title;
        book.author = this.author;
        book.copyright = this.copyright;
        book.ISBN = this.ISBN;
    }

    public void setISBN(String ISBN)
    {
        this.ISBN = ISBN;
    }
    public void setAuthor(String author)
    {
        this.author = author;
    }
    public void setTitle(String title)
    {
        this.title = title;
    }
    public void setCopyright(String copyright)
    {
        this.copyright = copyright;
    }
    private String ISBN;
    private String author;
    private String title;
    private String copyright;

}