package com.corejdo.casestudy.usecase;


import com.corejdo.casestudy.model.*;
import com.corejdo.casestudy.tools.CmdLine;

import javax.jdo.*;

import java.util.*;
import java.text.DateFormat;
import java.text.ParseException;

/**
 * Returns a book.
 * @author Heiko Bobzin, Keiron McCammon, Sameer Tyagi, Michael Vorburger
 * @version 1.0
 */

public class ReturnBook extends BorrowReturn
{
    public static void main(String[] args)
    {
        new ReturnBook().runCmdLine(args);
    }

    /**
     * Command line version of the book editor.
     */
    protected void run(String[] args)
    {
        setFindISBN(CmdLine.getStringVar("Find ISBN","1-2153-1882-3"));
        execute();
        System.out.println("Place returned copy at "+location);
    }

    protected void process(Book book)
    {
        Copy copy[] = findCopies(book);
        for (int i = 0; i < copy.length; i++) {
            Copy c = copy[i];
            if (c.borrower == getContext().user) {
                c.borrower = null;
                this.location = c.location;
                return ;
            }
        }
        throw new UseCaseException("This book is not borrowed by "+getContext().user+". Please ask clerk.");
    }

}