package com.corejdo.casestudy.usecase;
import com.corejdo.casestudy.model.User;
import com.corejdo.casestudy.model.Rights;

import javax.servlet.http.*;
import javax.servlet.*;
import javax.jdo.*;

/**
 * This class provides helper methods for JSP beans to find the right
 * session context. If the ServletHelper is used, the persistence manager
 * is associated with the servlet's session context through this object.
 * It implements the

 * @author Heiko Bobzin, Keiron McCammon, Sameer Tyagi, Michael Vorburger
 * @version 1.0
 */

public class ServletHelper implements
    HttpSessionBindingListener
{
    private Context context;

    public ServletHelper()
    {
    }

    /**
     * This method must be called in the JSP code to associate the
     * context/session with the use case.
     */
    public synchronized void useBean(AbstractUseCase uc)
    {
        uc.setContext(getContext());
    }

    synchronized Context getContext()
    {
        if (context == null) {
            context = new Context();
        }
        return context;
    }

    public void valueBound(HttpSessionBindingEvent event)
    {
    }

    public static final String NAME = "helper";

    public synchronized void valueUnbound(HttpSessionBindingEvent event)
    {
        if (event.getName().equals(NAME)) {
            if (context != null) {
    System.err.println("Closed context for session "+event.getSession().getId());
                context.close();
                context = null;
            }
        }
    }


    public static String checkBox(String name, boolean isChecked)
    {
        return "<input type=\"checkbox\" name=\""+name+"\" "+
         (isChecked?"checked":"")+" value=\"true\" border=\"0\" >";
    }

    public static boolean checkBox(String name, HttpServletRequest req)
    {
        String param = req.getParameter(name);
        return (param != null && param.equals("true"));
    }
}