package com.corejdo.examples.chapter5;

import java.util.*;
import javax.jdo.*;
import com.corejdo.examples.util.*;

/**
 * <p>This example prints the <code>PersistenceManagerFactory</code> 
 * supported options.</p>
 * <p>It gets a <code>PersistenceManagerFactory</code> instance via the
 * {@link com.corejdo.examples.util.PersistenceManagerFactoryHelper} class,
 * therefore <code>jdo.properties</code> system property should be set 
 * to a valid properties file for the JDO implementation being used.</p>
 * 
 * @author mccammon
 * @see com.corejdo.examples.util.PersistenceManagerFactoryHelper
 *
 */
public class SupportedOptionsExample {

  /**
   * <p>Used to run the example. No command line arguments are required.</p>
   * 
   * @param args command line arguments
   */
  public static void main(String args[]) {

    PersistenceManagerFactory pmf =
      PersistenceManagerFactoryHelper.getPersistenceManagerFactory();

    Iterator iter = pmf.supportedOptions().iterator();

    System.out.println(
      "PersistenceManagerFactory class '"
        + pmf.getClass().getName()
        + "' supports:");

    while (iter.hasNext()) {

      String option = (String) iter.next();

      System.out.println("  " + option);
    }
  }
  
  private SupportedOptionsExample() {}
}
