package com.corejdo.examples.chapter7;

import com.corejdo.examples.util.PersistenceManagerFactoryHelper;
import com.corejdo.examples.model.Author;
import com.corejdo.examples.model.Book;

import javax.jdo.PersistenceManagerFactory;
import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.jdo.Query;
import java.util.Collection;
import java.util.Iterator;
import java.util.Date;

public class FilterExamples {


    public static void main(String agrs[]) {

        // The properties file contains all configuration
// properties
        PersistenceManagerFactory pmf =
                PersistenceManagerFactoryHelper.getPersistenceManagerFactory();

        PersistenceManager pm = pmf.getPersistenceManager();
        Transaction tx = pm.currentTransaction();


        tx.begin();
       System.out.println("--------------example 1-----------------------")      ;
        // find all authors who's name starts with "S"

        String filter = "name.startsWith(\"S\") ";
        Query query = pm.newQuery(Author.class, filter);
        Collection results = (Collection) query.execute();
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Author author = (Author) iter.next();
                String name = author.getName();
                System.out.println("Author's name is " + name);
                System.out.println("Author's address is " + author.getAddress());
                System.out.println("Author's books are " );
                Iterator books=author.getBooks().iterator();
                while(books.hasNext())
                       System.out.println("Book:" +books.next()) ;

            }
        }
        query.closeAll();

       System.out.println("---------------example 2----------------------") ;
     // find all authors whose living in zipcode 02929
        filter = "address.zipcode==\"02929\"";
        query = pm.newQuery(Author.class, filter);
        results = (Collection) query.execute();
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Author author = (Author) iter.next();
                String name = author.getName();
                System.out.println("Author's name is " + name);
                System.out.println("Author's address is " + author.getAddress());
                System.out.println("Author's books are " );
                Iterator books=author.getBooks().iterator();
                while(books.hasNext())
                       System.out.println("Book:" +books.next()) ;
              }
        }
        query.closeAll();

        System.out.println("---------------example 3----------------------") ;
        // find all books with a certain publisher name and date
        filter = "(publisher.name== pubname) && (publicationDate < today)";
        query = pm.newQuery(Book.class, filter);
        Date today= new Date();
        String pubname="Pet publishin Co";
        query.declareImports("import java.util.Date;")  ;
        query.declareParameters("Publisher pubname,Date today");
        results = (Collection) query.execute(pubname,today);
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Book book = (Book) iter.next();
                System.out.println("Book found "+book);
                }
        }

        // repeat query execution with new value  for pubname and date if needed

        pubname="Books123.com";
        results = (Collection) query.execute(pubname,today);
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Book book = (Book) iter.next();
                System.out.println("Book found "+book);
                }
        }
        query.closeAll();

        System.out.println("---------------example 4----------------------") ;

        filter = "books.contains(myfavouritebook) && " +
                "(myfavouritebook.title==\"Learn Java Today\")";
        query = pm.newQuery(Author.class, filter);
        query.declareVariables("Book myfavouritebook");
        results = (Collection) query.execute();
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Author author = (Author) iter.next();
                String name = author.getName();
                System.out.println("Author's name is " + name);
                System.out.println("Author's address is " + author.getAddress());
                System.out.println("Author's books are " );
                Iterator books=author.getBooks().iterator();
                while(books.hasNext())
                       System.out.println("Book:" +books.next()) ;

            }
        }
        query.closeAll();

        System.out.println("---------------example 5----------------------") ;

        query = pm.newQuery(Book.class);
        query.setOrdering("title ascending,publicationDate decending");
        results = (Collection) query.execute();
        if (results.isEmpty())
            System.out.println("No results found");
      else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Book book = (Book) iter.next();
                System.out.println("Book found "+book);
                }
        }
        query.closeAll();

        System.out.println("--------------example 6-----------------------")      ;
        // Show an example of a cast

       //  filter = "((String)name).startsWith(\"S\") ";
          filter = "name.startsWith(\"S\") ";
         query = pm.newQuery(Author.class, filter);
         results = (Collection) query.execute();
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Author author = (Author) iter.next();
                String name = author.getName();
                System.out.println("Author's name is " + name);
                System.out.println("Author's address is " + author.getAddress());
                System.out.println("Author's books are " );
                Iterator books=author.getBooks().iterator();
                while(books.hasNext())
                       System.out.println("Book:" +books.next()) ;

            }
        }
        query.closeAll();

        System.out.println("--------------example 7-----------------------")      ;
  // example for usage of  "this" operator
        filter = "books.contains(name) && " +
                "(this.name==\"Steven Jones\")";
        query = pm.newQuery(Author.class, filter);
        query.declareVariables("Book name");
        results = (Collection) query.execute();
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Author author = (Author) iter.next();
                String name = author.getName();
                System.out.println("Author's name is " + name);
                System.out.println("Author's address is " + author.getAddress());
                System.out.println("Author's books are " );
                Iterator books=author.getBooks().iterator();
                while(books.hasNext())
                       System.out.println("Book:" +books.next()) ;

            }
        }
        query.closeAll();
        tx.commit();
    }
}
