package com.corejdo.examples.chapter7;

import com.corejdo.examples.model.Author;
import com.corejdo.examples.model.Address;
import com.corejdo.examples.util.PersistenceManagerFactoryHelper;

import javax.jdo.*;


public class ObjectIdExample {

    public static void main(String[] args) throws Exception {

// The properties file contains all configuration
// properties
        PersistenceManagerFactory pmf =
                PersistenceManagerFactoryHelper.getPersistenceManagerFactory();

        PersistenceManager pm = pmf.getPersistenceManager();

// create and persist the object
        Transaction tx = pm.currentTransaction();
        tx.begin();
        Author author =
          new Author(
            "Sameer Tyagi",
            new Address(
              "1 Main Street", "Boston", "MA", "01822"));

        pm.makePersistent(author);
        Object oid= pm.getObjectId(author);
        tx.commit();


        // Everything is saved and closed
        // Lets try finding the object now afresh using the object ID we have.

        pm = pmf.getPersistenceManager();
        tx = pm.currentTransaction();
        tx.begin();
        System.out.println("Finding Object with JDO Identity as " + oid);
        Author foundauthor = (Author) pm.getObjectById(oid, false);
        System.out.println("Author successfully found " + foundauthor.getName());
        tx.commit();
        pm.close();
    }
}