package com.corejdo.examples.chapter7;

import com.corejdo.examples.model.*;
import com.corejdo.examples.util.PersistenceManagerFactoryHelper;

import javax.jdo.*;
import java.util.Date;

public class SeedDatabaseForQueries {

    public static void main(String[] args) throws Exception {

    // The properties file contains all configuration
        PersistenceManagerFactory pmf =
                PersistenceManagerFactoryHelper.getPersistenceManagerFactory();

        PersistenceManager pm = pmf.getPersistenceManager();

// create and persist the object
        Transaction tx = pm.currentTransaction();
        tx.begin();
        // create an author with a book and address

        Book book1= new Book("Who let the dogs out","28277222",new Date());
        Publisher publisher1= new Publisher("Pet publishin Co");
        book1.setPublisher(publisher1);

        Address address1= new Address("1 Main Street","Burlington","02929","MA");
        Author author1 = new Author("Snoop Smith",address1);
        author1.addBook(book1);
        // make author1 persistent
        pm.makePersistent(author1);


        // create an author with a book and address

        Book book2= new Book("Learn Java Today","82098123",new Date());
        Publisher publisher2= new Publisher("Books123.com");
        book2.setPublisher(publisher2);

        Address address2= new Address("12 Park Av","New York","10221","NY");
        Author author2 = new Author("Steven Jones",address2);
        author2.addBook(book2);
     // make author2 persistent
        pm.makePersistent(author2);



        // create an author with a book and address
        Book book3= new Book("EJB for Dummies","2938723897",new Date());
        Publisher publisher3= new Publisher("Java Book Co");
        book3.setPublisher(publisher3);

        Address address3= new Address("72A Lakeside View Drive","Hudson","03088","NH");
        Author author3 = new Author("Lisa Knowles",address3);
        author3.addBook(book3);
     // make author3 persistent
        pm.makePersistent(author3);


       // create an author with only an address and add as co author for previous book
        // by Lisa Knowles
        Address address4= new Address("72A Lakeside View Drive","Hudson","03088","NH");
        Author author4 = new Author("John Knowles",address4);
        author4.addBook(book3);
     // make author4 persistent
        pm.makePersistent(author4);
        tx.commit();
        pm.close();

    }
}
