package com.corejdo.examples.chapter7;

import com.corejdo.examples.util.PersistenceManagerFactoryHelper;
import com.corejdo.examples.model.Author;

import javax.jdo.PersistenceManagerFactory;
import javax.jdo.PersistenceManager;
import javax.jdo.Transaction;
import javax.jdo.Query;
import java.util.Collection;
import java.util.Iterator;

public class SimpleQueryWithFilter {


    public static void main(String agrs[]) {

        // The properties file contains all configuration
// properties
        PersistenceManagerFactory pmf =
                PersistenceManagerFactoryHelper.getPersistenceManagerFactory();

        PersistenceManager pm = pmf.getPersistenceManager();
        Transaction tx = pm.currentTransaction();


        tx.begin();

        // find all author objects where the name is Snoop Smith
        String filter = "address.zipcode==\"02929\" ";
        Query query = pm.newQuery(Author.class, filter);
        Collection results = (Collection) query.execute();
        if (results.isEmpty())
            System.out.println("No results found");
        else {

            Iterator iter = results.iterator();
            while (iter.hasNext()) {
                Author author = (Author) iter.next();
                String name = author.getName();
                System.out.println("Author's name is " + name);
                System.out.println("Author's address is " + author.getAddress());
                System.out.println("Author's books are " );
                Iterator books=author.getBooks().iterator();
                    while(books.hasNext())
                            System.out.println("Book:" +books.next()) ;

            }
        }
        query.closeAll();
        tx.commit();

    }
}
