package com.corejdo.examples.model;

/**
 * <p>This class represents a street address in the USA.</p>
 * <p>It represents an address as the string fields street, city, zipcode and state
 * and has JavaBean style getters/setters for each field.</p>
 * 
 * @author mccammon
 * 
 */
public class Address {

  protected String street;
  protected String city;
  protected String zipcode;
  protected String state;

  /**
   * <p>Constructs an address with the specified street, city, zipcode and state.</p>
   * 
   * @param street the number and street name
   * @param city the city name
   * @param zipcode the zipcode
   * @param state the state
   */
  public Address(String street, String city, String zipcode, String state) {

    this.street = street;
    this.city = city;
    this.zipcode = zipcode;
    this.state = state;
  }
  
  protected Address() {}

  /**
   * <p>Gets the street.</p>
   * 
   * @return the street
   */
  public String getStreet() {

    return street;
  }

  /**
   * <p>Sets the street.</p>
   * 
   * @param street the street
   */
  public void setStreet(String street) {

    this.street = street;
  }

  /**
   * <p>Gets the zipcode.</p>
   * 
   * @return the zipcode
   */
  public String getZipcode() {

    return zipcode;
  }

  /**
   * <p>Sets the zipcode.</p>
   * 
   * @param zipcode the zipcode
   */
  public void setZipcode(String zipcode) {

    this.zipcode = zipcode;
  }

  /**
   * <p>Gets the state.</p>
   * 
   * @return the state
   */
  public String getState() {

    return state;
  }

  /**
   * <p>Sets the state.</p>
   * 
   * @param state the state
   */
  public void setState(String state) {

    this.state = state;
  }
  
  /**
   * <p>Gets the city.</p>
   * 
   * @return the city
   */
  public String getCity() {
    
    return city;
  }

  /**
   * <p>Sets the city.</p>
   * 
   * @param city the city
   */
  public void setCity(String city) {
    
    this.city = city;
  }
}
